diff --git a/app/controllers/api/v2/config_templates_controller.rb b/app/controllers/api/v2/config_templates_controller.rb
index 7492db45b..a6cc00096 100644
--- a/app/controllers/api/v2/config_templates_controller.rb
+++ b/app/controllers/api/v2/config_templates_controller.rb
@@ -5,7 +5,7 @@ module Api
       include Api::TaxonomyScope
       include Foreman::Renderer
 
-      before_filter :find_resource, :only => [:show, :update, :destroy]
+      before_filter(:only => %w{show update destroy}) { find_resource('templates') }
       before_filter :handle_template_upload, :only => [:create, :update]
       before_filter :process_template_kind, :only => [:create, :update]
       before_filter :process_operatingsystems, :only => [:create, :update]
@@ -17,7 +17,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @config_templates = ConfigTemplate.search_for(*search_options).paginate(paginate_options).
+        @config_templates = ConfigTemplate.
+          authorized(:view_templates).
+          search_for(*search_options).paginate(paginate_options).
           includes(:operatingsystems, :template_combinations, :template_kind)
       end
 
@@ -60,7 +62,7 @@ module Api
       param :version, String, :desc => "template version"
 
       def revision
-        audit = Audit.find(params[:version])
+        audit = Audit.authorized(:view_audit_logs).find(params[:version])
         render :json => audit.revision.template
       end
 
@@ -74,7 +76,7 @@ module Api
       api :GET, "/config_templates/build_pxe_default", "Change the default PXE menu on all configured TFTP servers"
 
       def build_pxe_default
-        status, msg = ConfigTemplate.build_pxe_default(self)
+        status, msg = ConfigTemplate.authorized(:deploy_templates).build_pxe_default(self)
         render :json => msg, :status => status
       end
 
diff --git a/app/controllers/api/v2/domains_controller.rb b/app/controllers/api/v2/domains_controller.rb
index c2ec7d90b..5b6583e4b 100644
--- a/app/controllers/api/v2/domains_controller.rb
+++ b/app/controllers/api/v2/domains_controller.rb
@@ -26,7 +26,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @domains = Domain.search_for(*search_options).paginate(paginate_options)
+        @domains = Domain.
+          authorized(:view_domains).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/domains/:id/", "Show a domain."
diff --git a/app/controllers/api/v2/environments_controller.rb b/app/controllers/api/v2/environments_controller.rb
index 972f25b9b..c06afd087 100644
--- a/app/controllers/api/v2/environments_controller.rb
+++ b/app/controllers/api/v2/environments_controller.rb
@@ -14,7 +14,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @environments = Environment.search_for(*search_options).paginate(paginate_options)
+        @environments = Environment.
+          authorized(:view_environments).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/environments/:id/", "Show an environment."
diff --git a/app/controllers/api/v2/fact_values_controller.rb b/app/controllers/api/v2/fact_values_controller.rb
index deacb9cdc..e27192560 100644
--- a/app/controllers/api/v2/fact_values_controller.rb
+++ b/app/controllers/api/v2/fact_values_controller.rb
@@ -1,7 +1,6 @@
 module Api
   module V2
     class FactValuesController < V2::BaseController
-      before_filter :find_resource, :only => %w{show update destroy}
       before_filter :setup_search_options, :only => :index
 
       api :GET, "/fact_values/", "List all fact values."
@@ -16,8 +15,8 @@ module Api
         @fact_values = FactValue.build_facts_hash(values.all)
       end
 
-      def resource_scope
-        FactValue.my_facts.no_timestamp_facts
+      def resource_scope(controller = controller_name)
+        FactValue.authorized(:view_facts).my_facts.no_timestamp_facts
       end
 
     end
diff --git a/app/controllers/api/v2/filters_controller.rb b/app/controllers/api/v2/filters_controller.rb
new file mode 100644
index 000000000..de10cf7c1
--- /dev/null
+++ b/app/controllers/api/v2/filters_controller.rb
@@ -0,0 +1,76 @@
+module Api
+  module V2
+    class FiltersController < V2::BaseController
+      include Api::Version2
+      include Api::TaxonomyScope
+
+      before_filter :find_role
+      before_filter :find_resource, :only => %w{show update destroy}
+
+      api :GET, "/filters/", "List all filters."
+      param :search, String, :desc => "filter results", :required => false
+      param :page, String, :desc => "paginate results"
+      param :per_page, String, :desc => "number of entries per request"
+
+      def index
+        @filters = resource_scope.search_for(*search_options).paginate(paginate_options)
+      end
+
+      api :GET, "/filters/:id/", "Show a filter."
+      param :id, :identifier, :required => true
+
+      def show
+      end
+
+      def_param_group :filter do
+        param :filter, Hash, :action_aware => true, :required => true do
+          param :role_id, String, :required => true
+          param :search, String
+          param :permission_ids, Array
+          param :organization_ids, Array
+          param :location_ids, Array
+        end
+      end
+
+      api :POST, "/filters/", "Create a filter."
+      param_group :filter, :as => :create
+
+      def create
+        @filter = Filter.new(params[:filter])
+        process_response @filter.save
+      end
+
+      api :PUT, "/filters/:id/", "Update a filter."
+      param :id, String, :required => true
+      param_group :filter
+
+      def update
+        process_response @filter.update_attributes(params[:filter])
+      end
+
+      api :DELETE, "/filters/:id/", "Delete a filter."
+      param :id, String, :required => true
+
+      def destroy
+        process_response @filter.destroy
+      end
+
+      private
+
+      def find_role
+        @role = Role.find_by_id(role_id)
+      end
+
+      def resource_scope(controller = controller_name)
+        @resource_scope ||= @role.present? ?
+            @role.filters.authorized("#{action_permission}_#{controller}") :
+            resource_class.scoped.authorized("#{action_permission}_#{controller}")
+      end
+
+      def role_id
+        params[:role_id]
+      end
+
+    end
+  end
+end
diff --git a/app/controllers/api/v2/host_classes_controller.rb b/app/controllers/api/v2/host_classes_controller.rb
index c44a18683..c3dc41b2b 100644
--- a/app/controllers/api/v2/host_classes_controller.rb
+++ b/app/controllers/api/v2/host_classes_controller.rb
@@ -10,7 +10,7 @@ module Api
       api :GET, "/hosts/:host_id/puppetclass_ids/", "List all puppetclass id's for host"
 
       def index
-        render :json => { root_node_name => HostClass.where(:host_id => host_id).pluck('puppetclass_id') }
+        render :json => { root_node_name => HostClass.authorized(:edit_classes).where(:host_id => host_id).pluck('puppetclass_id') }
       end
 
       api :POST, "/hosts/:host_id/puppetclass_ids", "Add a puppetclass to host"
@@ -27,7 +27,7 @@ module Api
       param :id, String, :required => true, :desc => "id of puppetclass"
 
       def destroy
-        @host_class = HostClass.where(:host_id => host_id, :puppetclass_id => params[:id])
+        @host_class = HostClass.authorized(:edit_classes).where(:host_id => host_id, :puppetclass_id => params[:id])
         process_response @host_class.destroy_all
       end
 
@@ -38,7 +38,7 @@ module Api
         if params[:host_id] =~ /^\d+$/
           return @host_id = params[:host_id].to_i
         else
-          @host ||= Host::Managed.find_by_name(params[:host_id])
+          @host ||= Host::Managed.authorized(:view_hosts).find_by_name(params[:host_id])
           return @host_id = @host.id if @host
           not_found
         end
diff --git a/app/controllers/api/v2/hostgroups_controller.rb b/app/controllers/api/v2/hostgroups_controller.rb
index 448178f5c..0ac7a2c8a 100644
--- a/app/controllers/api/v2/hostgroups_controller.rb
+++ b/app/controllers/api/v2/hostgroups_controller.rb
@@ -14,7 +14,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @hostgroups = Hostgroup.includes(:hostgroup_classes, :group_parameters).
+        @hostgroups = Hostgroup.
+          authorized(:view_hostgroups).
+          includes(:hostgroup_classes, :group_parameters).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v2/hosts_controller.rb b/app/controllers/api/v2/hosts_controller.rb
index 849924832..842e6184f 100644
--- a/app/controllers/api/v2/hosts_controller.rb
+++ b/app/controllers/api/v2/hosts_controller.rb
@@ -7,7 +7,9 @@ module Api
       include Api::TaxonomyScope
       include Foreman::Controller::SmartProxyAuth
 
-      before_filter :find_resource, :except => [:index, :create, :facts]
+      before_filter :find_resource, :except => %w{index create facts}
+      before_filter :permissions_check, :only => %w{power boot puppetrun}
+
       add_puppetmaster_filters :facts
 
       api :GET, "/hosts/", "List all hosts."
@@ -104,11 +106,6 @@ Return value may either be one of the following:
         render :json => { :status => @host.host_status }.to_json if @host
       end
 
-      # we need to limit resources for a current user
-      def resource_scope
-        Host.my_hosts
-      end
-
       api :PUT, "/hosts/:id/puppetrun", "Force a puppet run on the agent."
       param :id, :identifier_dottable, :required => true
 
@@ -158,6 +155,25 @@ Return value may either be one of the following:
 
       private
 
+      def resource_scope(controller = controller_name)
+        Host.authorized("#{action_permission}_#{controller}", Host)
+      end
+
+      def action_permission
+        case params[:action]
+          when 'puppetrun'
+            :puppetrun
+          when 'power'
+            :power
+          when 'boot'
+            :ipmi_boot
+          when 'console'
+            :console
+          else
+            super
+        end
+      end
+
       # this is required for template generation (such as pxelinux) which is not done via a web request
       def forward_request_url
         @host.request_url = request.host_with_port if @host.respond_to?(:request_url)
@@ -175,6 +191,10 @@ Return value may either be one of the following:
         raise ::Foreman::Exception.new("A problem occurred when detecting host type: #{e.message}")
       end
 
+      def permissions_check
+        permission = "#{params[:action]}_hosts".to_sym
+        deny_access unless Host.authorized(permission).find(@host.id)
+      end
     end
   end
 end
diff --git a/app/controllers/api/v2/images_controller.rb b/app/controllers/api/v2/images_controller.rb
index 4b7c40ec3..acf77d585 100644
--- a/app/controllers/api/v2/images_controller.rb
+++ b/app/controllers/api/v2/images_controller.rb
@@ -12,8 +12,9 @@ module Api
       param :compute_resource_id, :identifier, :required => true
 
       def index
-        @images = @compute_resource.images.search_for(*search_options).paginate(paginate_options)
-        @total = @compute_resource.images.count
+        base = @compute_resource.images.authorized(:view_images)
+        @images = base.search_for(*search_options).paginate(paginate_options)
+        @total = base.count
       end
 
       api :GET, "/compute_resources/:compute_resource_id/images/:id/", "Show an image"
@@ -63,7 +64,7 @@ module Api
       private
 
       def find_compute_resource
-        @compute_resource = ComputeResource.find(params[:compute_resource_id])
+        @compute_resource = ComputeResource.authorized(:view_compute_resources).find(params[:compute_resource_id])
       end
 
     end
diff --git a/app/controllers/api/v2/media_controller.rb b/app/controllers/api/v2/media_controller.rb
index 847058c73..0788de4a2 100644
--- a/app/controllers/api/v2/media_controller.rb
+++ b/app/controllers/api/v2/media_controller.rb
@@ -34,7 +34,9 @@ Available families:
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @media = Medium.search_for(*search_options).paginate(paginate_options)
+        @media = Medium.
+          authorized(:view_media).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/media/:id/", "Show a medium."
diff --git a/app/controllers/api/v2/models_controller.rb b/app/controllers/api/v2/models_controller.rb
index ad9b17c84..25504fc80 100644
--- a/app/controllers/api/v2/models_controller.rb
+++ b/app/controllers/api/v2/models_controller.rb
@@ -10,7 +10,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @models = Model.search_for(*search_options).paginate(paginate_options)
+        @models = Model.
+          authorized(:view_models).
+          search_for(*search_options).
+          paginate(paginate_options)
       end
 
       api :GET, "/models/:id/", "Show a model."
diff --git a/app/controllers/api/v2/operatingsystems_controller.rb b/app/controllers/api/v2/operatingsystems_controller.rb
index cc237dac7..99e673429 100644
--- a/app/controllers/api/v2/operatingsystems_controller.rb
+++ b/app/controllers/api/v2/operatingsystems_controller.rb
@@ -16,6 +16,7 @@ module Api
 
       def index
         @operatingsystems = Operatingsystem.
+          authorized(:view_operatingsystems).
           includes(:media, :architectures, :ptables, :config_templates, :os_default_templates).
           search_for(*search_options).paginate(paginate_options)
       end
@@ -66,8 +67,8 @@ module Api
       param :architecture, String
 
       def bootfiles
-        medium = Medium.find_by_name(params[:medium])
-        arch   = Architecture.find_by_name(params[:architecture])
+        medium = Medium.authorized(:view_media).find_by_name(params[:medium])
+        arch   = Architecture.authorized(:view_architectures).find_by_name(params[:architecture])
         render :json => @operatingsystem.pxe_files(medium, arch)
       rescue => e
         render :json => e.to_s, :status => :unprocessable_entity
diff --git a/app/controllers/api/v2/override_values_controller.rb b/app/controllers/api/v2/override_values_controller.rb
index f033f40a7..ecaba9f23 100644
--- a/app/controllers/api/v2/override_values_controller.rb
+++ b/app/controllers/api/v2/override_values_controller.rb
@@ -63,6 +63,7 @@ module Api
         render 'api/v2/override_values/show'
       end
 
+      private
       def find_override_values
         if @smart
           @override_values = @smart.lookup_values.paginate(paginate_options)
diff --git a/app/controllers/api/v2/parameters_controller.rb b/app/controllers/api/v2/parameters_controller.rb
index 68fb756a1..8f47ee17c 100644
--- a/app/controllers/api/v2/parameters_controller.rb
+++ b/app/controllers/api/v2/parameters_controller.rb
@@ -136,6 +136,15 @@ module Api
 
       private
 
+      def action_permission
+        case params[:action]
+          when 'reset'
+            :destroy
+          else
+            super
+        end
+      end
+
       def parameters_method
         # hostgroup.rb has a method def parameters, so I didn't create has_many :parameters like Host, Domain, Os
         nested_obj.is_a?(Hostgroup) ? :group_parameters : :parameters
diff --git a/app/controllers/api/v2/permissions_controller.rb b/app/controllers/api/v2/permissions_controller.rb
new file mode 100644
index 000000000..c043fa2ac
--- /dev/null
+++ b/app/controllers/api/v2/permissions_controller.rb
@@ -0,0 +1,32 @@
+module Api
+  module V2
+    class PermissionsController < V2::BaseController
+      before_filter :find_resource, :only => %w{show}
+
+      api :GET, "/permissions/", "List all permissions."
+      param :page, String, :desc => "paginate results"
+      param :per_page, String, :desc => "number of entries per request"
+      param :resource_type, String
+      param :name, String
+
+      def index
+        type = params[:resource_type].blank? ? nil : params[:resource_type]
+        name = params[:name].blank? ? nil : params[:name]
+        if type
+          @permissions = Permission.find_all_by_resource_type(type)
+        elsif name
+          @permissions = Permission.find_all_by_name(name)
+        else
+          @permissions = Permission.all
+        end
+      end
+
+      api :GET, "/permissions/:id/", "Show a permission."
+      param :id, :identifier, :required => true
+
+      def show
+      end
+
+    end
+  end
+end
diff --git a/app/controllers/api/v2/ptables_controller.rb b/app/controllers/api/v2/ptables_controller.rb
index ed239b0c8..832aefb2b 100644
--- a/app/controllers/api/v2/ptables_controller.rb
+++ b/app/controllers/api/v2/ptables_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @ptables = Ptable.search_for(*search_options).paginate(paginate_options)
+        @ptables = Ptable.
+          authorized(:view_ptables).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/ptables/:id/", "Show a ptable."
diff --git a/app/controllers/api/v2/reports_controller.rb b/app/controllers/api/v2/reports_controller.rb
index c8a95f799..f81da8eac 100644
--- a/app/controllers/api/v2/reports_controller.rb
+++ b/app/controllers/api/v2/reports_controller.rb
@@ -15,7 +15,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @reports = Report.my_reports.includes(:logs => [:source, :message]).
+        @reports = Report.
+          authorized(:view_reports).
+          my_reports.
+          includes(:logs => [:source, :message]).
           search_for(*search_options).paginate(paginate_options)
         @total = Report.my_reports.count
       end
@@ -58,8 +61,8 @@ module Api
 
       def last
         conditions = { :host_id => Host.find_by_name(params[:host_id]).try(:id) } unless params[:host_id].blank?
-        max_id = Report.my_reports.where(conditions).maximum(:id)
-        @report = Report.includes(:logs => [:message, :source]).find(max_id)
+        max_id = Report.authorized(:view_reports).my_reports.where(conditions).maximum(:id)
+        @report = Report.authorized(:view_reports).includes(:logs => [:message, :source]).find(max_id)
         render :show
       end
 
diff --git a/app/controllers/api/v2/roles_controller.rb b/app/controllers/api/v2/roles_controller.rb
index baa810ec7..835b762c3 100644
--- a/app/controllers/api/v2/roles_controller.rb
+++ b/app/controllers/api/v2/roles_controller.rb
@@ -1,7 +1,6 @@
 module Api
   module V2
     class RolesController < V2::BaseController
-      before_filter :require_admin
       before_filter :find_resource, :only => %w{show update destroy}
 
       api :GET, "/roles/", "List all roles."
diff --git a/app/controllers/api/v2/smart_proxies_controller.rb b/app/controllers/api/v2/smart_proxies_controller.rb
index 29b5012b8..3dfca2f5b 100644
--- a/app/controllers/api/v2/smart_proxies_controller.rb
+++ b/app/controllers/api/v2/smart_proxies_controller.rb
@@ -63,8 +63,17 @@ module Api
 
       private
       def proxies_by_type(type = nil)
-        return SmartProxy.includes(:features).try(type.downcase+"_proxies") if type.present?
-        return SmartProxy.includes(:features).scoped
+        return SmartProxy.authorized(:view_smart_proxies).includes(:features).try(type.downcase+"_proxies") if type.present?
+        return SmartProxy.authorized(:view_smart_proxies).includes(:features).scoped
+      end
+
+      def action_permission
+        case params[:action]
+        when 'refresh'
+          :edit
+        else
+          super
+        end
       end
 
       def check_feature_type
diff --git a/app/controllers/api/v2/statistics_controller.rb b/app/controllers/api/v2/statistics_controller.rb
index 94a2ad5ca..e059c8eaa 100644
--- a/app/controllers/api/v2/statistics_controller.rb
+++ b/app/controllers/api/v2/statistics_controller.rb
@@ -6,22 +6,22 @@ module Api
       api :GET, "/statistics/", "Get statistics"
 
       def index
-        @os_count    = Host.my_hosts.count_distribution :operatingsystem
-        @arch_count  = Host.my_hosts.count_distribution :architecture
-        @env_count   = Host.my_hosts.count_distribution :environment
-        @klass_count = Host.my_hosts.count_habtm "puppetclass"
-        @cpu_count   = FactValue.my_facts.count_each "processorcount"
-        @model_count = FactValue.my_facts.count_each "manufacturer"
-        @mem_size    = FactValue.my_facts.mem_average "memorysize"
-        @mem_free    = FactValue.my_facts.mem_average "memoryfree"
-        @swap_size   = FactValue.my_facts.mem_average "swapsize"
-        @swap_free   = FactValue.my_facts.mem_average "swapfree"
-        @mem_totsize = FactValue.my_facts.mem_sum "memorysize"
-        @mem_totfree = FactValue.my_facts.mem_sum "memoryfree"
-        render :json => { :os_count    => @os_count, :arch_count => @arch_count,
-                                            :env_count   => @env_count, :klass_count => @klass_count, :cpu_count => @cpu_count,
-                                            :model_count => @model_count, :mem_size => @mem_size, :mem_free => @mem_free, :swap_size => @swap_size,
-                                            :swap_free   => @swap_free, :mem_totsize => @mem_totsize, :mem_totfree => @mem_totfree }
+        @os_count    = Host.authorized(:view_hosts).count_distribution :operatingsystem
+        @arch_count  = Host.authorized(:view_hosts).count_distribution :architecture
+        @env_count   = Host.authorized(:view_hosts).count_distribution :environment
+        @klass_count = Host.authorized(:view_hosts).count_habtm "puppetclass"
+        @cpu_count   = FactValue.authorized(:view_facts).my_facts.count_each "processorcount"
+        @model_count = FactValue.authorized(:view_facts).my_facts.count_each "manufacturer"
+        @mem_size    = FactValue.authorized(:view_facts).my_facts.mem_average "memorysize"
+        @mem_free    = FactValue.authorized(:view_facts).my_facts.mem_average "memoryfree"
+        @swap_size   = FactValue.authorized(:view_facts).my_facts.mem_average "swapsize"
+        @swap_free   = FactValue.authorized(:view_facts).my_facts.mem_average "swapfree"
+        @mem_totsize = FactValue.authorized(:view_facts).my_facts.mem_sum "memorysize"
+        @mem_totfree = FactValue.authorized(:view_facts).my_facts.mem_sum "memoryfree"
+        render :json => { :os_count    => @os_count,    :arch_count => @arch_count,   :swap_size => @swap_size,
+                          :env_count   => @env_count,   :klass_count => @klass_count, :cpu_count => @cpu_count,
+                          :model_count => @model_count, :mem_size => @mem_size,       :mem_free => @mem_free,
+                          :swap_free   => @swap_free,   :mem_totsize => @mem_totsize, :mem_totfree => @mem_totfree }
       end
 
     end
diff --git a/app/controllers/api/v2/subnets_controller.rb b/app/controllers/api/v2/subnets_controller.rb
index dd19b96f0..cdababf52 100644
--- a/app/controllers/api/v2/subnets_controller.rb
+++ b/app/controllers/api/v2/subnets_controller.rb
@@ -14,7 +14,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @subnets = Subnet.includes(:tftp, :dhcp, :dns).
+        @subnets = Subnet.
+          authorized(:view_subnets).
+          includes(:tftp, :dhcp, :dns).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v2/template_combinations_controller.rb b/app/controllers/api/v2/template_combinations_controller.rb
index fc8cff548..3dd355be3 100644
--- a/app/controllers/api/v2/template_combinations_controller.rb
+++ b/app/controllers/api/v2/template_combinations_controller.rb
@@ -36,7 +36,7 @@ module Api
       end
 
       def find_parent_config_template
-        @config_template = ConfigTemplate.find(params[:config_template_id])
+        @config_template = ConfigTemplate.authorized(:view_templates).find(params[:config_template_id])
         not_found unless @config_template
         @config_template
       end
diff --git a/app/controllers/api/v2/usergroups_controller.rb b/app/controllers/api/v2/usergroups_controller.rb
index 9a251e103..79ca59592 100644
--- a/app/controllers/api/v2/usergroups_controller.rb
+++ b/app/controllers/api/v2/usergroups_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :order, String, :desc => "sort results"
 
       def index
-        @usergroups = Usergroup.search_for(*search_options).paginate(paginate_options)
+        @usergroups = Usergroup.
+          authorized(:view_usergroups).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/usergroups/:id/", "Show a usergroup."
diff --git a/app/controllers/api/v2/users_controller.rb b/app/controllers/api/v2/users_controller.rb
index af8c74533..1f2af027f 100644
--- a/app/controllers/api/v2/users_controller.rb
+++ b/app/controllers/api/v2/users_controller.rb
@@ -1,10 +1,10 @@
 module Api
   module V2
     class UsersController < V2::BaseController
+      before_filter :find_resource, :only => %w{show update destroy}
       include Foreman::Controller::UsersMixin
       include Api::Version2
       include Api::TaxonomyScope
-      before_filter :find_resource, :only => %w{show update destroy}
 
       api :GET, "/users/", "List all users."
       param :search, String, :desc => "filter results"
@@ -13,14 +13,15 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @users = User.search_for(*search_options).paginate(paginate_options)
+        @users = User.
+          authorized(:view_users).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/users/:id/", "Show an user."
       param :id, String, :required => true
 
       def show
-        @user
       end
 
       def_param_group :user do
diff --git a/app/controllers/application_controller.rb b/app/controllers/application_controller.rb
index e79d97a05..390345b10 100644
--- a/app/controllers/application_controller.rb
+++ b/app/controllers/application_controller.rb
@@ -10,6 +10,7 @@ class ApplicationController < ActionController::Base
 
   # standard layout to all controllers
   helper 'layout'
+  helper_method :authorizer
 
   before_filter :require_ssl, :require_login
   before_filter :set_gettext_locale_db, :set_gettext_locale
@@ -45,6 +46,10 @@ class ApplicationController < ActionController::Base
     authorized ? true : deny_access
   end
 
+  def authorizer
+    @authorizer ||= Authorizer.new(User.current, :collection => instance_variable_get("@#{controller_name}"))
+  end
+
   def deny_access
     (User.current.logged? || request.xhr?) ? render_403 : require_login
   end
@@ -111,7 +116,7 @@ class ApplicationController < ActionController::Base
   end
 
   def model_of_controller
-    controller_path.singularize.camelize.gsub('/','::').constantize
+    @model_of_controller ||= controller_path.singularize.camelize.gsub('/','::').constantize
   end
 
 
@@ -124,10 +129,38 @@ class ApplicationController < ActionController::Base
     not_found and return if params[:id].blank?
 
     name = controller_name.singularize
-    model = model_of_controller
-    # determine if we are searching for a numerical id or plain name
     cond = "find" + (params[:id] =~ /\A\d+(-.+)?\Z/ ? "" : "_by_name")
-    not_found and return unless instance_variable_set("@#{name}", model.send(cond, params[:id]))
+    not_found and return unless instance_variable_set("@#{name}", resource_base.send(cond, params[:id]))
+  end
+
+  def current_permission
+    [action_permission, controller_permission].join('_')
+  end
+
+  def controller_permission
+    controller_name
+  end
+
+  def action_permission
+    case params[:action]
+      when 'new', 'create'
+        'create'
+      when 'edit', 'update'
+        'edit'
+      when 'destroy'
+        'destroy'
+      when 'index', 'show'
+        'view'
+      else
+        raise ::Foreman::Exception.new(N_("unknown permission for %s"), "#{params[:controller]}##{params[:action]}")
+    end
+  end
+
+  # not all models includes Authorizable so we detect whether we should apply authorized scope or not
+  def resource_base
+    @resource_base ||= model_of_controller.respond_to?(:authorized) ?
+        model_of_controller.authorized(current_permission) :
+        model_of_controller.scoped
   end
 
   def notice notice
diff --git a/app/controllers/architectures_controller.rb b/app/controllers/architectures_controller.rb
index ad8a7105e..7e9604eb4 100644
--- a/app/controllers/architectures_controller.rb
+++ b/app/controllers/architectures_controller.rb
@@ -3,7 +3,8 @@ class ArchitecturesController < ApplicationController
   before_filter :find_by_name, :only => %w{edit update destroy}
 
   def index
-    @architectures = Architecture.includes(:operatingsystems).search_for(params[:search], :order => params[:order]).paginate(:page => params[:page])
+    base = resource_base.includes(:operatingsystems).search_for(params[:search], :order => params[:order])
+    @architectures = base.paginate(:page => params[:page])
   end
 
   def new
diff --git a/app/controllers/audits_controller.rb b/app/controllers/audits_controller.rb
index 7a0a3a123..ac1316dce 100644
--- a/app/controllers/audits_controller.rb
+++ b/app/controllers/audits_controller.rb
@@ -4,11 +4,18 @@ class AuditsController < ApplicationController
   before_filter :setup_search_options, :only => :index
 
   def index
-    Audit.unscoped { @audits = Audit.search_for(params[:search], :order => params[:order]).paginate :page => params[:page] }
+    Audit.unscoped { @audits = resource_base.search_for(params[:search], :order => params[:order]).paginate :page => params[:page] }
   end
 
   def show
-    @audit = Audit.find(params[:id])
-    @history = Audit.descending.where(:auditable_id => @audit.auditable_id, :auditable_type => @audit.auditable_type)
+    @audit = resource_base.find(params[:id])
+    @history = resource_base.descending.where(:auditable_id => @audit.auditable_id, :auditable_type => @audit.auditable_type)
   end
+
+  private
+
+  def controller_permission
+    'audit_logs'
+  end
+
 end
diff --git a/app/controllers/auth_source_ldaps_controller.rb b/app/controllers/auth_source_ldaps_controller.rb
index f5992ff9b..341f078a5 100644
--- a/app/controllers/auth_source_ldaps_controller.rb
+++ b/app/controllers/auth_source_ldaps_controller.rb
@@ -1,6 +1,8 @@
 class AuthSourceLdapsController < ApplicationController
+  before_filter :find_by_name, :only => [:edit, :update, :destroy]
+
   def index
-    @auth_source_ldaps = AuthSourceLdap.all
+    @auth_source_ldaps = resource_base.all
   end
 
   def new
@@ -17,11 +19,9 @@ class AuthSourceLdapsController < ApplicationController
   end
 
   def edit
-    @auth_source_ldap = AuthSourceLdap.find(params[:id])
   end
 
   def update
-    @auth_source_ldap = AuthSourceLdap.find(params[:id])
     # remove from hash :account_password if blank?
     params[:auth_source_ldap].except!(:account_password) if params[:auth_source_ldap][:account_password].blank?
     if @auth_source_ldap.update_attributes(params[:auth_source_ldap])
@@ -32,12 +32,10 @@ class AuthSourceLdapsController < ApplicationController
   end
 
   def destroy
-    @auth_source_ldap = AuthSourceLdap.find(params[:id])
     if @auth_source_ldap.destroy
       process_success
     else
       process_error
     end
-
   end
 end
